#include "margi.h"
#include "ts2pes.h"
#include "margi_ipack.h"

void margi_setup_ts2pes(struct ipack *pa, struct ipack *pv, u16 *pida, u16 *pidv, 
		  void (*pes_write)(u8 *buf, int count, void *data),
		  void *priv)
{
	margi_ipack_init(pa, IPACKS, pes_write);
	margi_ipack_init(pv, IPACKS, pes_write);
	pa->pid = pida;
	pv->pid = pidv;
	pa->data = priv;
	pv->data = priv;
}

void margi_ts_to_pes(struct ipack *p, u8 *buf) // don't need count (=188)
{
	u8 off = 0;

	if (!buf || !p ){
		printk("NULL POINTER IDIOT\n");
		return;
	}
	if (buf[1]&PAY_START) {
		if (p->plength == MMAX_PLENGTH-6 && p->found>6){
			p->plength = p->found-6;
			p->found = 0;
			margi_send_ipack(p);
			margi_ipack_reset(p);
		}
	}
	if (buf[3] & ADAPT_FIELD) {  // adaptation field?
		off = buf[4] + 1;
		if (off+4 > 187) return;
	}
	margi_ipack_instant_repack(buf+4+off, TS_SIZE-4-off, p);
}

